/* GCC */

#include <bits/stdc++.h>

using namespace std;

typedef long long ull;
typedef vector <ull> vec;
//typedef vector <ull[2]> vec2;

int n, m, i;

bool iseasy(ull a) {
    bool yes = true;
    for (i = 2; i <= a / 2; i++) {
        if (a % i == 0) {
            yes = false;
        }
    }
    if (a < 2) {
        return false;
    }
    return yes;
}

vec fact(ull a) {
ull i;
vec result;
    for (i = 2; i <= a / 2; i++) {
        if (a % i == 0 && iseasy(i)) {
            result.push_back({i});
            while (a % i == 0) {
                a /= i;
            }
        }
    }
    return result;
}

vec factn(ull a) {
ull i;
vec result;
    for (i = 2; i <= a / 2; i++) {
        if (a % i == 0 && iseasy(i)) {
            result.push_back({0});
            while (a % i == 0) {
                a /= i;
                result[result.size() - 1]++;
            }
        }
    }
    return result;
}

ull coldel(ull a) {
    ull x = 1, i;
    vec v;
    v = factn(a);
    for (i = 0; i < v.size(); i++) {
        x *= v[i] + 1;
    }
}

ull pow(ull a, ull b) {
    ull x = 1;
    for (i = 0; i < b; i++) {
        x *= a;
    }
}

void print(ull m, ull n) {
    int i, j;
    int M[n][n / 2], mM[n];
    vec v2;
    v2 = fact(m);
    for (i = 0; i < n - 1; i++) {
        for (j = 0; j < n / 2; j++) {
            M[i][j] = v2[(i + j) % m];
            mM[i] *= M[i][j];
        }
        cout << mM[i] * m << " ";
    }
    for (j = 0; j < n / 2; j++) {
            M[n - 1][j] = v2[(n - 1 + j) % m];
            mM[n - 1] *= M[n - 1][j];
        }
        cout << mM[n - 1] * m << endl;
}

int main() {
    freopen("divisors.in","r",stdin);
    freopen("divisors.out","w",stdout);
    cin.tie();
    cout.tie();
    cin >> m >> n;
    if (coldel(m) > n || n % 2 == 1 && !(sqrt(n) == floor(sqrt(n)))) {
        cout << 0 << endl;
        return 0;
    }
    else {
        vec v, v1;
        v = fact(m);
        v1 = factn(m);
        if (coldel(m) == n) {
                cout << m << endl;
                return 0;
        }
        else {
            ull n1 = n - coldel(m);
            print(m, n1);
        }
    }
    return 0;
}
