/* GCC */
#include <iostream>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <set>

#define ll unsigned long long int

using namespace std;

bool* ert;
vector<int> dl;

vector<ll> get_prime_divisors(ll m) {
    ll h = m;
    ert = new bool[m];
    vector<ll> divisors;
    for (ll i = 2;i <= (h + 1) / 2;i++) {
        if (m % i == 0)
            dl.push_back(i);
        if (ert[i] == false) {
            ert[i] = true;
            while (m % i == 0) {
                divisors.push_back(i);
                m /= i;
            }
            for (ll j = i;j < m;j += i) {
                ert[j] = true;
            }
        }
    }
    dl.push_back(h);
    return divisors;
}

ll fact(int n) {
    if (n == 1)
        return 1;
    return fact(n - 1) * n;
}

int main() {
    freopen("divisors.in", "r", stdin);
    freopen("divisors.out", "w", stdout);
    cin.tie(0);
    cout.tie(0);
    std::ios_base::sync_with_stdio(false);
    ll m, n;
    cin >> m >> n;
    vector<ll> m_divisors = get_prime_divisors(m);
    int divisors_need = n - dl.size() - 2;
    //for (int i = 0;i < dl.size();i++) {
     //   cout << dl[i] << endl;
    //}
    vector<ll> up_divisors;
    for (ll i = 0;i < m_divisors.size();i++) {
        if (ert[m_divisors[i]] == true) {
            up_divisors.push_back(m_divisors[i]);
            ert[m_divisors[i]] = false;
        }
    }
    if (divisors_need < 1) {
        cout << 0 << endl;
        fclose(stdout);
        return 0;
    }
    //cout << "as" << endl;
    //cout << ert[5] << endl;
    //for (int i = 0;i < up_divisors.size();i++) {
    //    cout << up_divisors[i] << endl;
    //}
    //cout << "as" << endl;
    //cout << divisors_need << endl;
    set<ll> values;
    values.insert(m);
    for (int i = 0;i < divisors_need;i++) {
        set<ll> new_values;
        for (set<ll>::iterator l = values.begin();l != values.end();l++) {
            ll c = *l;
            for (int j = 0;j < up_divisors.size();j++) {
                new_values.insert(up_divisors[j] * c);
            }
        }
        values = new_values;
    }
    for (set<ll>::iterator l = values.begin();l != values.end();) {
        if (*l != m) {
            cout << *l;
            l++;
            if (l != values.end()) {
                cout << " ";
            }
        } else
        l++;
    }
    cout << endl;
    fclose(stdout);
    fclose(stdin);
    return 0;
}
