/* GCC */
#include <iostream>
#include <fstream>

using namespace std;

unsigned int* divideToTwo (unsigned int number, unsigned int n) {

    unsigned int* arr = new unsigned int[2];

    if (number % 2 == 0) {

        unsigned int* dv = divideToTwo(number / 2, n + 1);

        arr[0] = dv[0];
        arr[1] = dv[1];

    } else {

        arr[0] = number;
        arr[1] = n;

    }

    return arr;

}

int main () {

    unsigned int N, A, B;
    unsigned short int K;

    ifstream fin ("cash.in");
    ofstream fout ("cash.out");

    fin >> N >> A >> B >> K;
    fin.close();

    if (N == 1) {

        fout << 0;

    } else if (N == 2) {

        fout << B;

    } else {

        if (K == 1 || N == K) {

            fout << (N - 2) * A + B;

        } else {

            unsigned int* division = divideToTwo(20, 0);

            fout << (division[1] + 1) * A + (division[0] / 2) * B;

            delete division;

        }

    }

    fout << endl;
    fout.close();

    return 0;
}
