/*GCC*/
#include <bits/stdc++.h>

typedef unsigned long long ll;
typedef long double ld;

using namespace std;

const int Nmax = 1e6+2, inf = 1e7;

int d[10];
int cnt_[10];
int extra = 1;
int sz = 0;
ll ans[Nmax];

ll multiply(ll a, ll b, ll mod) {
    ll res = 0;
    while(b) {
        if(b & 1)
            res = (res + a) % mod;
        a = (a + a) % mod;
        b >>= 1;
    }
    return res;
}
ll bin_pow(ll a, ll b, ll mod) {
    ll res = 1;
    while(b) {
        if(b & 1)
            res = multiply(res, a, mod);
        a = multiply(a, a, mod);
        b >>= 1;
    }
    return res;
}
bool is_prime(ll n) {
    if(n == 1 || n == 2)
        return 1;
    int s = 0;
    ll d = n-1;
    while(!(d & 1))
        d >>= 1, s++;
    ll x;
    bool check = false;
    for(int i = 0;i < 20;++i) {
        x = (1ll * rand() * RAND_MAX + rand()) % n;
        if(x == 0)
            continue;
        check = 0;
        if(bin_pow(x, d, n) == 1)
            check = 1;
        for(int i = 0;i < s && !check;++i)
            if(bin_pow(x, d * (1ll << i), n) == n-1)
                check = 1;
        if(!check)
            return 0;
    }
    return 1;
}
inline int cnt() {
    int res = 1;
    for(int i = 0;d[i];++i)
        res *= (cnt_[i]+1);
    return res * extra;
}
int n;
void factor(ll x) {
    ll m = x;
    for(int i = 2;1ll*i*i*i <= m;++i) {
        if(x % i == 0)
            d[sz++] = i;

        while(x % i == 0) {
            cnt_[sz-1]++;
            x/=i;
        }

        if(cnt() > n)
            break;
    }

    if(1ll * inf * inf > x) {
    for(unsigned i = 2;1ll*i*i <= x;++i) {
        if(x % i == 0)
            d[sz++] = i;
        while(x % i == 0) {
            cnt_[sz-1]++;
            x/=i;
        }
        if(cnt() > n)
            break;
    }
    if(x > 1)
        d[sz] = x,
        cnt_[sz++] = 1;
    }
    else {
        if(is_prime(x)) {
            extra = 2;
            return;
        }
        m = sqrt(x);
        if(m*m == x)
            extra = 3;
        else
            extra = 4;
    }
}

void perebor(int pos, ll num) {
    int hv = cnt();
    if(hv == n)
        ans[sz++] = num;
    if(d[pos] == 0 || hv >= n)
        return;

    for(int i = 0;i <= n-hv;++i) {
        perebor(pos+1, num);
        num *= d[pos];
        cnt_[pos]++;
    }
    cnt_[pos] -= n-hv+1;
}
int main()
{
	freopen("divisors.in", "r", stdin);
	freopen("divisors.out", "w", stdout);
    srand(time(0));
    ll m;
    cin >> m >> n;
    factor(m);
    if(cnt() > n) {
        cout << 0 << '\n';
        return 0;
    }


    sz = 0;
    perebor(0, m);
    if(sz == 0) {
        cout << 0 << '\n';
        return 0;
    }
    sort(ans, ans+sz);
    for(int i = 0;i < sz;++i) {
        cout << ans[i];
        if(i != sz-1)
            cout << ' ';
        else
            cout << '\n';
    }
    return 0;
}

