#include <iostream>
#include <fstream>
#include <cmath>
#include <vector>

using namespace std;

unsigned long long int FindDiv(unsigned long long int Number)
{
    if(Number == 2) return 2;
    if(Number == 3) return 2;
    if(Number == 4) return 3;
    if(Number == 5) return 2;
    if(Number == 6) return 4;
    if(Number == 7) return 2;
    if(Number == 8) return 4;
    if(Number == 9) return 3;
    if(Number == 10) return 4;
    if(Number == 11) return 2;
    if(Number == 12) return 6;
    if(Number == 13) return 2;
    if(Number == 14) return 4;
    if(Number == 15) return 4;
    if(Number == 16) return 5;
    if(Number == 17) return 2;
    if(Number == 18) return 6;
    if(Number == 19) return 2;
    if(Number == 20) return 6;
    unsigned long long int Amount = 0;
    for(unsigned long long int i = 1; i <= Number; i++) if(Number % i == 0) Amount++;
    return Amount;
}

bool IsPrime(unsigned long long int Number)
{
    if(Number == 0 || Number == 1) return false;
    if(Number == 2 ||
        Number == 3 ||
        Number == 5 ||
        Number == 7 ||
        Number == 11 ||
        Number == 13 ||
        Number == 17 ||
        Number == 19 ||
        Number == 23) return true;
    if(Number % 2 == 0) return false;
    unsigned long long int TempNumber = Number;
    int Sum = 0;
    while(TempNumber != 0) {
        Sum += TempNumber % 10;
        TempNumber /= 10;
    }
    if(Sum % 3 == 0) return false;
    for(unsigned long long int i = 2; i <= sqrt(Number); i++) if(Number % i == 0) return false;
    return true;
}

void FindPrimeDiv(unsigned long long int Number, vector< unsigned long long int > &NumberPrimeDiv)
{
    if(Number != 0 || Number != 1) for(unsigned long long int i = 2; i < Number / 2; i++) if(Number % i == 0 && IsPrime(i)) NumberPrimeDiv.push_back(i);
}

int main()
{
    ifstream Input("divisors.in");
    ofstream Output("divisors.out");
    unsigned long long int M, N;
    vector< unsigned long long int > MPrimeDiv;
    vector< unsigned long long int > Ans;
    Input >> M >> N;
    FindPrimeDiv(M, MPrimeDiv);
    vector< unsigned long long int > Finder(MPrimeDiv.size());
    for(unsigned int i = 0; i < Finder.size(); i++) Finder[i] = 0;
    bool Flag = true;
    while(Flag) {
        int Counter = 0;
        for(unsigned int i = 0; i < Finder.size(); i++) if(Finder[i] == N) Counter++;
        if(Counter == Finder.size()) Flag = false;

        int Sum = 0;
        unsigned long long int NumAns = 1;
        for(unsigned int i = 0; i < Finder.size(); i++) Sum += Finder[i];
        for(unsigned int i = 0; i < Finder.size(); i++) NumAns *= (unsigned long long int)round(pow(MPrimeDiv[i], Finder[i]));
        Ans.push_back(NumAns);

        bool Flag2 = true;
        bool Flag3 = true;
        int i = Finder.size() - 1;
        while(Flag3 && i != 0) {
            if(Finder[i] == N) {
                Finder[i] = 0;
                Finder[i - 1]++;
                Flag2 = false;
                i--;
            }
            else Flag3 = false;
        }
        if(Flag2) Finder[Finder.size() - 1]++;
    }
    vector< unsigned long long int > Ans2;
    for(int i = 0; i < Ans.size(); i++) {
        if(FindDiv(Ans[i]) == N && Ans[i] > M) Ans2.push_back(Ans[i]);
    }
    if(Ans2.size() == 0) Output << 0;
    else for(unsigned int i = 0; i < Ans2.size(); i++) Output << Ans2[i] << ' ';
    Output << endl;
    Input.close();
    Output.close();
    return 0;
}
