/* GCC */
#include <bits/stdc++.h>

using namespace std;

const long t_o = 15;

typedef long long ll;
typedef pair<int,int> pii;

unsigned long long m,n,bm;
vector<pair<long long,long> > rs;
vector<unsigned long long> an_s;
map<pair<long long, long long>,bool>u;

long long p_w(long long a,long b){
    if(!b)return 1;
    long long t = p_w(a,b/2);
    if(b%2 == 1)return (((t*t)%m)*a)%m;
    return (t*t)%m;
}

long long rn_d(long long m){
    long long r = 0;
    for(long i = 0;i < 4;i++){
        r = ((r*RAND_MAX)%m+rand())%m;
    }
    if(r)return r;
    return 1;
}

bool prime_1(long long m){
    if(m == 1)return 0;
    if(m == 2)return 1;
    for(long i = 0;i < t_o;i++){
        long long a = rn_d(m);
        if(p_w(a,m-1) != 1)return 0;
    }
    return 1;
}

pair<long long,long long> gt_hsh(vector<pair<long long, long> >& v){
    long long r1 = 0,r2 = 0;
    long long p_p = 31;
    long long mod1 = 1000000007;
    long long mod2 = 1000000009;
    for(long i = 0;i < v.size();i++){
        r1 *= p_p;
        r2 *= p_p;
        r1 += v[i].first;
        r2 += v[i].second;
        r1 %= mod1;
        r2 %= mod2;
    }
    return {r1,r2};
}

void rec(vector <pair<long long,long> >& v,long n,long temp,unsigned long long m){
    pair<long long,long long> H_h = gt_hsh(v);
    if(u[H_h])return;
    u[H_h] = 1;
    if(temp == n){
        an_s.push_back(m);
        return;
    }
    for(long i = 0;i < v.size();i++){
        v[i].second++;
        if(m*v[i].first > m && temp/v[i].second*(v[i].second+1) <= n)
            rec(v,n,temp/v[i].second*(v[i].second+1),m*v[i].first);
        v[i].second--;
        if(m*v[i].first <= m)break;
    }
}

int main()
{
    freopen("divisors.in","r",stdin);
    freopen("divisors.out","w",stdout);
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    cin >> m >> n;
    bm = m;
    if(m <= 1000ll*10000*1000*10000){
        for(long long i = 2;i*i <= m;i++){
            long t = 0;
            while(m%i == 0)
                m/=i,t++;
            if(t)rs.push_back(make_pair(i,t));
        }
        if(m > 1)rs.push_back(make_pair(m,1));
    }else{
        for(long long i = 2;i <= cbrt(m);i++){
            long t = 0;
            while(m%i == 0)
                m/=i,t++;
            if(t)rs.push_back(make_pair(i,t));
        }
        if(m > 1){
            long long adad;
            if(prime_1(m))
                adad = 2;
            else adad = 4;
            if(n%adad == 0)n /= adad;
            else{
                cout << 0 << '\n';
                return 0;
            }
        }
    }
    long long tempn = 1;
    for(long i = 0;i < rs.size();i++)
        tempn *= (rs[i].second+1);
    if(tempn > n){
        cout << 0 << '\n';
        return 0;
    }
    if(tempn == n){
        cout << bm << '\n';
        return 0;
    }
    rec(rs,n,tempn,bm);
    sort(an_s.begin(),an_s.end());
    if(an_s.size() > 0)
        for(long i = 0;i < an_s.size();i++)
            if(i != an_s.size()-1)cout << an_s[i] << ' ';
            else cout << an_s[i] << '\n';
    else cout << 0 << '\n';
    return 0;
}
