/* GCC */
#pragma GCC optimize("O3")
#include <bits/stdc++.h>

using namespace std;

#define int unsigned long long

const int M3=2.7e6;

int rnd()
{
    int res=0;
    for(int i=0;i<4;i++)
        res=res*RAND_MAX+rand();
}

int padd(int x,int y,int m)
{
    x=x%m;
    y=y%m;
    int res=x+y;
    if(x>m-y) /// x+y>m
        res-=m;
    return res;
}

int pmult(int x,int y,int m)
{
    int res=0;
    while(y)
    {
        if(y&(int)1)
            res=padd(res,x,m);
        x=padd(x,x,m);
        y>>=1;
    }
    return res;
}

int ppow(int x,int y,int m)
{
    int res=1;
    while(y)
    {
        if(y&(int)1)
            res=pmult(res,x,m);
        x=pmult(x,x,m);
        y>>=1;
    }
    return res;
}

int ppow(int x,int y)
{
    int res=1;
    while(y)
    {
        if(y&(int)1)
            res=res*x;
        x=x*x;
        y>>=1;
    }
    return res;
}

/// count of distinct divisors of m <= 15

vector< pair<int,int> > pm;
vector<int> ans;

void per(int i,int s,int r,int t)
{
    if(i+1==pm.size()) /// i==pm.size()-1
    {
        if(pm[i].second+1<=s) /// pm[i]<=s-1
            ans.push_back(t*ppow(pm[i].first,s-1));
    }
    else
    {
        r/=pm[i].second+1;
        for(int d=pm[i].second+1;d*r<=s;d++)
            if(s%d==0)
                per(i+1,s/d,r,t*ppow(pm[i].first,d-1));
    }
}

signed main()
{
    #define name "divisors"
    freopen(name".in","r",stdin);
    freopen(name".out","w",stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    srand(time(0));
    int m,n;
    cin>>m>>n;
    for(int p=2;p<=M3;p++)
        if(m%p==0)
        {
            int k=0;
            while(m%p==0)
                m/=p,k++;
            pm.push_back(make_pair(p,k));
        }
    if(m>1)
    {
        int s=sqrt((long double)m);
        while(s*s<m) s++;
        while(s*s>m) s--;
        if(s*s==m)
            pm.push_back(make_pair(s,2));
        else
        {
            bool prime=true;
            for(int i=0;i<20;i++)
            {
                int a=rand()%(m-2)+2;
                if(__gcd(a,m)!=1)
                {
                    prime=false;
                    break;
                }
                if(ppow(a,m-1,m)!=1)
                {
                    prime=false;
                    break;
                }
            }
            if(prime)
                pm.push_back(make_pair(m,1));
            else
                pm.push_back(make_pair(1,1)),
                pm.push_back(make_pair(m,1));
        }
    }
    int r=1;
    for(int i=0;i<pm.size();i++)
        r*=pm[i].second+1;
    per(0,n,r,1);
    sort(ans.begin(),ans.end());
    if(ans.empty())
        cout<<"0\n";
    else for(int i=0;i<ans.size();i++)
        cout<<ans[i]<<(i+1==ans.size()?"\n":" ");
}
