/* GCC */

#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdio>

using namespace std;

long long pow(long long a,long long n)
{
    long long i,res;
    res = 1;
    for (i = 1;i <= n;i++) res *= a;
    return res;
}

int comp(const void* a1,const void* b1)
{
    long long a = *(long long*)a1;
    long long b = *(long long*)b1;
    if (a > b) return 1;
    return -1;
}

int main()
{
    freopen("divisors.in","r",stdin);
    freopen("divisors.out","w",stdout);
    long long m,n;
    cin >> m >> n;
    long long i,j,np;
    vector<long long> p(6,1);
    vector<long long> a(6,0);
    vector<long long> ans;
    long long s = m;
    np = 1;
    j = 2;
    long long pa = (a[1]+1)*(a[2]+1)*(a[3]+1)*(a[4]+1)*(a[5]+1);
    while(s > 1)
    {
        if(np > 5)
        {
            cout << 0 << "\n";
            return 0;
        }
        if (s%j == 0)
        {
            while(s%j == 0)
            {
                p[np] = j;
                s /= j;
                a[np]++;
            }
            np++;
        }
        else j++;
    }
    long long x1,x2,x3,x4,x5;
    long long x1m,x2m,x3m,x4m,x5m;
    x1m = (n*(a[1]+1))/pa-a[1]-1;
    x2m = (n*(a[2]+1))/pa-a[2]-1;
    x3m = (n*(a[3]+1))/pa-a[3]-1;
    x4m = (n*(a[4]+1))/pa-a[4]-1;
    x5m = (n*(a[5]+1))/pa-a[5]-1;
    for (x1 = 0;x1 <= x1m;x1++)
    {
        for (x2 = 0;x2 <= x2m;x2++)
        {
            for (x3 = 0;x3 <= x3m;x3++)
            {
                for (x4 = 0;x4 <= x4m;x4++)
                    {
                        for (x5 = 0;x5 <= x5m;x5++)
                        {
                            if(!ans.empty() && (x1+a[1]+1)*(x2+a[2]+1)*(x3+a[3]+1)*(x4+a[4]+1)*(x5+a[5]+1) == n) if(ans[ans.size()-1] != pow(p[1],x1)*pow(p[2],x2)*pow(p[3],x3)*pow(p[4],x4)*pow(p[5],x5)) ans.push_back(pow(p[1],x1)*pow(p[2],x2)*pow(p[3],x3)*pow(p[4],x4)*pow(p[5],x5));
                            if(ans.empty() && (x1+a[1]+1)*(x2+a[2]+1)*(x3+a[3]+1)*(x4+a[4]+1)*(x5+a[5]+1) == n) ans.push_back(pow(p[1],x1)*pow(p[2],x2)*pow(p[3],x3)*pow(p[4],x4)*pow(p[5],x5));
                        }
                    }
            }
        }
    }
    qsort(&(ans[0]),ans.size(),sizeof(long long),comp);
    if (ans.empty())
    {
        cout << 0 << "\n";
        return 0;
    }
    cout << ans[0]*m;
    for (i = 1; i < ans.size();i++) cout << " " << ans[i]*m;
    cout << "\n";
}
