/* GCC */
#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
const ll INF = 1000000000010;

int main()
{
    freopen("cash.in", "rt", stdin);
    freopen("cash.out", "wt", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n, a, b, k;
    cin>> n >> a >> b >> k;
    if(n == 1)
    {
        cout<< 0 << "\n";
        return 0;
    }
    if(k == 1)
    {
        cout<< (n - 2) * a + b << "\n";
        return 0;
    }

    vector<vector<ll> > dp(n + 1, vector<ll>(k + 1));

    for(int i = 1; i <= n; i++)
        dp[i][1] = (i - 2) * a + b;

    for(int i = 1; i <= k; i++)
        dp[1][i] = 0;

    for(ll i = 2; i <= n; i++)
    {
        for(ll j = 2; j <= k; j++)
        {
            ll res = INF;
            for(int l = 1; l <= k && (i + l - 1) / l >= 2; l++)
            {
                int hills = (i + l - 1) / l;
                if(l == 1)
                    res = min(b + a * (hills - 2), res);
                else if(i % l == 0)
                    res = min(dp[l][j] + a * (hills - 1), res);
                else
                {
                    if(i % l == 1)
                        res = min(res, dp[l][j - 1] + b + a * (hills - 2));
                    else
                        res = min(res, dp[i % l][j - 1] + b + a * (hills - 1));
                }
            }
            dp[i][j] = res;
        }
    }

    /*for(int i = 1; i <= n; i++)
    {
        for(int j = 1; j <= k; j++)
            cout<< dp[i][j] << ' ';

        cout<< "\n";
    }*/

    cout<< dp[n][k] << "\n";

    return 0;
}
