/* GCC */


#include <iostream>
#include <string>
#include <string.h>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <iomanip>
#include <bitset>
#include <queue>


/*
♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥
♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥
♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥
♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥
♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥
♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥
♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥
♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥
♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥
♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥
♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥
♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥
♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥
*/


#define int long long
#define pii pair<int,int>
#define en '\n'

using namespace std;

typedef long long ll;

ll dp[1000100][11];

const ll  INF64=1000000000000000000;
const int INF32=1000000000;

ll a,b;

ll up_div(ll &n,ll &d){
    return (n+d-1)/d;
}

ll cost1,cost2;

ll DP(int n,int k){
    if (dp[n][k] != -1) return dp[n][k];
    if (n == 1){
        dp[n][k]=0;
        return 0;
    }
    if (k == 1){
        dp[n][k]=(n-2)*a+b;
        return dp[n][k];
    }
    dp[n][k]=INF64;
    for (int len = 1; len < n; ++len){
        cost1=DP(n%len,k - 1) + (up_div(n,len) - 1)*a;
        cost2=DP(len,k - 1) + (up_div(n,len)-2)*a + b;
        if (n%len==0) cost1=cost2;
        dp[n][k]=min(dp[n][k],max(cost1,cost2));
    }
    return dp[n][k];
}

void build(){
    for (int i=0; i<1000100; ++i)
        for (int j=0; j<11; ++j)
        dp[i][j]=-1;
}

signed main()
{
    freopen("cash.in","r",stdin); freopen("cash.out","w",stdout);
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    build();
    int n,k;
    cin>>n>>a>>b>>k;
    cout<<DP(n,k)<<en;
    return 0;
}










