/* GCC */


#include <iostream>
#include <string>
#include <string.h>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <iomanip>
#include <bitset>
#include <queue>
#include <time.h>
#include <cstdio>
/*
♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥
♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥
♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥
♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥
♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥
♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥
♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥
♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥
♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥
♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥
♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥
♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥
♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥♥
*/


#define pii pair<int,int>
#define en '\n'

typedef long long ll;
typedef unsigned long long ull;

//#define int ull

using namespace std;

vector < pair<ull,ull> > DEVS;

vector < vector <ull> > states;

void build (vector <ull> state, ull ost){
    if (ost==1){
        if (state.size()==DEVS.size()){
            states.push_back(state);
        }
        return;
    }
    for (ull i=2; i<=ost; ++i){
        if (ost%i==0){
            state.push_back(i);
            build(state,ost/i);
            state.pop_back();
        }
    }
}

vector <vector <pair <ull,ull> > > ans;

struct bigint{
    vector <int> d;
};

vector <bigint> ANS;

bigint make_from(ull x){
    bigint res;
    while (x){
        res.d.push_back(x%10);
        x/=10;
    }
    return res;
}
void write(bigint x){
    for (int i=x.d.size()-1; i>=0; --i)
        cout<<x.d[i];

}

bigint sum(bigint x, bigint y){
    bigint res;
    //cout<<en;
    //cout<<"SUM "; write(x); cout<<" "; write(y); cout<<en;
    while (x.d.size()<y.d.size()) x.d.push_back(0);
    while (x.d.size()>y.d.size()) y.d.push_back(0);
    int dop=0;
    for (int i=0; i<x.d.size(); ++i){
        res.d.push_back((x.d[i]+y.d[i]+dop)%10);
        dop=((x.d[i]+y.d[i]+dop))/10;
    }
    if (dop) res.d.push_back(dop);
    //write(res); cout<<en;
    return res;
}

bigint mult_fo (bigint x, int y){
    bigint res;
    for (int i=0; i<y; ++i)
        res=sum(res,x);
    return res;
}

bigint mult (bigint x, bigint y){
    //cout<<"MULT"<<en;
    //write(x); cout<<" "; write(y); cout<<en;
    bigint res;
    for (int i=0; i<y.d.size(); ++i){
        //cout<<"I "<<i<<" ";
        bigint test;
        test=mult_fo(x,y.d[i]);
        //write(test); cout<<" ";
        bigint need;
        for (int j=0; j<i; ++j){
            need.d.push_back(0);
        }
        for (int j=0; j<test.d.size(); ++j){
            need.d.push_back(test.d[j]);
        }
       // write(need); cout<<" ";
        res=sum(res,need);
        //write(res); cout<<" ";
        //cout<<en;
    }
    //write(res);
    //cout<<en;
    return res;
}

bool operator <(bigint x, bigint y){
    if (x.d.size()<y.d.size())
        return 1;
    if (x.d.size()>y.d.size())
        return 0;
    for (int i=x.d.size()-1; i>=0; --i){
        if (x.d[i]!=y.d[i]){
            return (x.d[i]<y.d[i]);
        }
    }

}



bigint poww(ull a,ull b){
    bigint res;
    res.d.push_back(1);
    bigint x=make_from(a);
    //cout<<"POWW "; cout<<a<<" "<<b<<en;
    for (ull i=0; i<b; ++i){
        res=mult(res,x);
        //cout<<i<<" "; write(res); cout<<en;
    }
    return res;
}




void adddd (vector < pair <ull,ull> > &VEC){
    bigint res;
    res.d.push_back(1);
    for (ull i=0; i<VEC.size(); ++i){
        res=mult(res,poww(VEC[i].first,VEC[i].second));
        //cout<<i<<" "<<VEC[i].first<<" "<<VEC[i].second<<" ";
        //write(res); cout<<en;
    }
    //cout<<"RES "; write(res); cout<<" !"<<en;
    ANS.push_back(res);
}

signed main()
{
    freopen("divisors.in","r",stdin); freopen("divisors.out","w",stdout);
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    ull n;
    cin>>n;
    ull n1=n;
    ull cnt;
    cin>>cnt;
    pair <ull,ull> x;
    //cout<<clock()*1.0/CLOCKS_PER_SEC<<en;
    for (ull i=2;  i*i<=n && i<=10000000; ++i){
        if (n1%i==0){
            x=make_pair(0,0);
            x.first=i;
            while (n1%i==0){
                x.second++;
                n1/=i;
            }
            DEVS.push_back(x);
        }
    }
    if (n1>1){
        DEVS.push_back(make_pair(n1,1));
    }
    vector <ull> help;
    build(help,cnt);
    /*
    for (ull i=0; i<states.size(); ++i){
        for (ull j=0; j<states[i].size(); ++j)
            cout<<states[i][j]<<" ";
        cout<<en;
    }
    */
    vector < pair <ull,ull> > HELP;

    for (ull i=0; i<states.size(); ++i){
            sort(DEVS.begin(),DEVS.end());
            bool fg=1;
            for (ull j=0; j<states[i].size(); ++j){
                if (states[i][j]-1<DEVS[j].second){
                    fg=0;
                    break;
                }
            }
            if (fg){
                HELP.clear();
                for (ull j=0; j<states[i].size(); ++j){
                    HELP.push_back(make_pair(DEVS[j].first,states[i][j]-1));
                }
                ans.push_back(HELP);
            }
    }

    for (ull i=0; i<ans.size(); ++i){
        //cout<<i<<en;
        adddd(ans[i]);
    }
    if (ANS.size()>0){
        sort(ANS.begin(),ANS.end());
    //cout<<ANS.size()<<en;
    for (ull i=0; i<ANS.size()-1; ++i){
        write(ANS[i]);
        //cout<<ANS[i].d.size()<<en;
        cout<<" ";
    }
    write(ANS.back());
    }else
        cout<<0;

    cout<<en;
    //cout<<clock()*1.0/CLOCKS_PER_SEC<<en;
    return 0;
}



















