/* GCC */
#include <iostream>
#include <fstream>
#include <vector>
#include <cmath>

using namespace std;

vector<int> getDi(int value)
{
    vector<int> r;
    for(register int i = 1; i <= value; i++)
    {
        if(value%i == 0) r.push_back(i);
    }
    return r;
}

vector<int> simple;

int main()
{
    ifstream fin("divisors.in");
    ofstream fout("divisors.out");
    simple.push_back(2);

    int m, n;
    fin >> m >> n;
    vector<int> dd = getDi(m);
    for(register int i = 2; i < 12000; i++)
    {
        int counter = 0;
        for(register int j = 2; j < 10; j++)
        {
            if(i%j == 0 && i != j)
            {
                counter++;
            }
        }
        if(counter == 0)
        {
            bool f = false;
            for(register int k = 0; k < dd.size(); k++)
            {
                if(dd[k] == i) f = true;
            }
            if(f) continue;
            simple.push_back(i);
        }
    }
    vector<int> res;
    for(register int i = 1; i < 12000; i++)
    {
        if(i%15 != 0) continue;
        vector<int> t = getDi(i);

        if(t.size() == n)
        {
            bool fal = true;
            for(register int j = 0; j < t.size(); j++)
            {
                for(register int l = 0; l < simple.size(); l++)
                {
                    if(t[j] == simple[l]) fal = false;
                    if(!fal) break;
                }
                if(!fal) break;
            }
            if(!fal) continue;
            res.push_back(i);
        }
    }
    if(res.size() == 0)
    {
        fout << 0 << endl;
    }
    for(register int i = 0; i < res.size(); i++)
    {
        if(i == res.size()-1)
        {
            fout << res[i] << endl;
            break;
        }
        fout << res[i] << " ";
    }
    return 0;
}
