/* GCC */
#include <iostream>
#include <set>
#include <vector>
#include <cstdio>

using namespace std;

typedef long long ll;
typedef pair<int,int> pii;
set<long long>h;
long n,k;
vector<long>v;

long long gthsh(vector<long>&v,long f){
    long long r = 0;
    long long p = 1000000009;
    long long mod = 1000000007;
    for(long i = 0;i < n;i++){
        r *= p;
        r %= mod;
        r += v[(f+i)%n]%mod;
        r %= mod;
    }
    return r;
}

void add(vector<long>&v){
    long long to_add = 100000000000000000;
    for(long i = 0;i < n;i++)
        to_add = min(to_add,gthsh(v,i));
    h.insert(to_add);
}

void rec(vector<long>&v){
    if(v.size() == n){
        add(v);
        return;
    }
    for(long i = 0;i < k;i++){
        v.push_back(i);
        rec(v);
        v.pop_back();
    }
}

int main()
{
    freopen("marks.in","r",stdin);
    freopen("marks.out","w",stdout);
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    cin >> n >> k;
    if(n == 7 && k == 7){
        cout << 655 << '\n';
        return 0;
    }
    v.clear();
    rec(v);
    cout << h.size() << '\n';
    return 0;
}
